//
//  GUI.hpp
//  TestSine
//
//  Created by Erik Zorzin on 22/10/15.
//  Copyright © 2015 Erik Zorzin. All rights reserved.
//

#ifndef GUI_hpp
#define GUI_hpp

#include "LinkRef.hpp"
#include "TROOT.h"
#include "TApplication.h"
#include "TVirtualX.h"
#include "TQObject.h"
#include "RQ_OBJECT.h"
#include "TGWindow.h"
#include "TGSlider.h"
#include "TGClient.h"
#include "TCanvas.h"
#include "TGraph.h"
#include "TAxis.h"
#include "TFrame.h"
#include "TPad.h"
#include "TRootEmbeddedCanvas.h"
#include "TGFrame.h"
#include "TPad.h"
#include "TMath.h"

const unsigned int  N = 100;                                                                                                    // Number of points in the graph [#].
const double        FS = 100;                                                                                                   // Sampling frequency [Hz].
const double        F = 2;                                                                                                      // Signal frequency [Hz].
const int           A = 1;                                                                                                      // Signal amplitude [m].

class TGWindow;
class TGMainFrame;
class TRootEmbeddedCanvas;

class GUI
{
    RQ_OBJECT("GUI")
    private:
        TGMainFrame*                fMain;
        TRootEmbeddedCanvas*        fEcanvas;
        TGHSlider*                  A_sld;                                                                                      // Amplitude slider.
        TGraph*                     graph;                                                                                      // Graph.
        TPad*                       pad;                                                                                        // Pad.
    public:
        GUI(const TGWindow* p, UInt_t w, UInt_t h);
        virtual ~GUI();
        void DoSlider(Int_t pos);
        void CloseApplication();
    
        //ClassDef(GUI, 0);                                                                                                     // ??? if I uncomment this, then the compilier cannot find symbols for x86-64 architecture.
};

#endif /* GUI_hpp */
